C***********************************************************************
C*  ColorNodes: finds maximal independent sets 
C*  This routine assigns a color to each site. The same color is assigned
C*  to all the sites that can be updated in parallel.  
C*
C***********************************************************************

      SUBROUTINE MISColorNodes
      
      INCLUDE 'string.h'

      INTEGER current_color, 
     &        numColored
      integer i, j, k , istate
      integer label_of_s(0:nm)
      integer save_label_of_s(0:nm)
      integer selected_s(0:nm)
      integer enabled_s(0:nm)
      integer last_enabled_s(0:nm)
      integer max_label(0:nm)
      logical mask(0:nm)
      integer labels_of_neighbors(0:max_neighbors, 0:nm)
CMPF  ONDPU  labels_of_neighbors
CMPF MAP labels_of_neighbors(MEMORY, ALLBITS)
      integer con_of_s(0:nm)
      integer max_con
      logical exitflag
      integer count_w_color(MAX_NUM_OF_COLOR)
CMPF MAP label_of_s(ALLBITS)
CMPF MAP save_label_of_s(ALLBITS)
CMPF MAP selected_s(ALLBITS)
CMPF MAP enabled_s(ALLBITS)
CMPF MAP last_enabled_s(ALLBITS)
CMPF MAP max_label(ALLBITS)
CMPF MAP mask(ALLBITS)
CMPF MAP con_of_s(ALLBITS)

        interface
            function pranmar( jstate )
            INCLUDE 'size.h'
            real, array(0:nm) :: pranmar
            integer jstate
            end function 
        end interface

      CALL FindAllNeighbors
     
      label_of_s = -1
      color_of_s = -1
      selected_s = 0 
      max_label = 0

      current_color = 1
      numColored = 0
      labels_of_neighbors = -1
c$$$      con_of_s = 2 * n_connectivity_s 
      con_of_s = n_connectivity_s 
      exitflag = .false.
      count_w_color = 0

      save_label_of_s = pranmar(istate) * 2**30
      max_con = MAXVAL(con_of_s) 
      do while ((numColored .le. nm) .and. (.not. exitflag)) 
       enabled_s = 1
       label_of_s = save_label_of_s
       last_enabled_s = 0
       do while (SUM(enabled_s) .gt. 1)
         last_enabled_s = enabled_s
         do j = 0, max_con-1
            where (j .lt. con_of_s) 
               labels_of_neighbors(j,:)=label_of_s( 
     &                               neighbors_of_s(j,:)) 
            endwhere
         enddo 
         mask = .false.
         where (color_of_s .eq. -1)
           mask = .true.
         endwhere
         do j = 0, max_con -1
            where ((j .lt. con_of_s) .and.
     $            (label_of_s .le. labels_of_neighbors(j,:)))
                mask = .false.
            endwhere
         enddo
         where (mask)
               selected_s = 1  
               enabled_s = 0 
               color_of_s = current_color
               label_of_s = -1
 	       save_label_of_s = -1
         end where  
C        print *, '# of enabled: ', SUM(enabled_s)
C        print 50, (enabled_s(i), i=0, nm)
C50      format(1x, 6I5)
         do j = 0, max_con-1
           where (selected_s .eq. 1) 
             enabled_s(neighbors_of_s(j,:)) = 0
	     label_of_s(neighbors_of_s(j,:)) = -1
     	   endwhere
         enddo
	 if (SUM(enabled_s) .eq. SUM(last_enabled_s)) enabled_s = 0
        enddo
        numColored = numColored + SUM(selected_s) 
        if (SUM(selected_s) .eq. 0) exitflag = .true.
        count_w_color(current_color) = SUM(selected_s)
        current_color = current_color + 1
        selected_s = 0 
      enddo 
      max_color = current_color - 1
c$$$      print 70,numColored, (count_w_color(k), k=1, max_color)
c$$$      print *,"Total number of colors:",max_color
c$$$  70  format ( 1x, I5, ' -:',20I3)
      RETURN
      end subroutine MISColorNodes 

