      SUBROUTINE set_up_random_graph

      INCLUDE 'string.h'

      integer i, l, l1, l2, v1, v2, maxcon, mincon
      real ranmar
      external ranmar

      n_connectivity_s = 0
      do i = 0, 3*n-1
        v1 = int(nm * (1.0 - ranmar()))
        v2 = mod(1 + int(v1 + (nm-1)*(1.0-ranmar())), n)
        if (v1 .eq. v2) print *, "Error : loop in graph!"
        l1 = 2*i
        l2 = 2*i + 1
        s_site_m(l1) = v1
        s_site_m(l2) = v2
        s_neighbor_m(l1) = v2
        s_neighbor_m(l2) = v1
        m_back_m(l1) = l2
        m_back_m(l2) = l1
        if (n_connectivity_s(v1) .eq. 0) then
          m_start_s(v1) = l1
          m_former_m(l1) = l1
          m_next_m(l1) = l1
        else
          l = m_start_s(v1)
          m_next_m(l1) = m_next_m(l)
          m_former_m(l1) = l
          m_former_m(m_next_m(l)) = l1
          m_next_m(l) = l1
        endif
        if (n_connectivity_s(v2) .eq. 0) then
          m_start_s(v2) = l2
          m_former_m(l2) = l2
          m_next_m(l2) = l2
        else
          l = m_start_s(v2)
          m_next_m(l2) = m_next_m(l)
          m_former_m(l2) = l
          m_former_m(m_next_m(l)) = l2
          m_next_m(l) = l2
        endif
        n_connectivity_s(v1) = n_connectivity_s(v1) + 1 
        n_connectivity_s(v2) = n_connectivity_s(v2) + 1 
      enddo
      maxcon = MAXVAL(n_connectivity_s)
      mincon = MINVAL(n_connectivity_s)
      print *, "Maximum degree = ", maxcon
      print *, "Minimum degree = ", mincon
      END SUBROUTINE set_up_random_graph
