C***********************************************************************
C*  ColorNodes: finds independent sets 
C*  This routine assigns a color to each site. The same color is assigned
C*  to all the sites that can be updated in parallel.  
C*
C***********************************************************************

      SUBROUTINE SmallestLastColorNodes
      
      INCLUDE 'string.h'

      integer weight(0:nm)
      integer maxnc , total_weighted, weighted_this_pass
      integer v(0:nm), neighbors(0:nm)
      INTEGER numColored
      integer i, j, k , istate
      integer label_of_s(0:nm)
      integer selected_s(0:nm)
      integer max_label(0:nm)
      integer free_color(0:nm)
      logical mask(0:nm)
      logical notusedcolorflag(0:nm)
      integer labels_of_neighbors(0:max_neighbors, 0:nm)
CMPF  ONDPU labels_of_neighbors
CMPF MAP labels_of_neighbors(MEMORY, ALLBITS)
      integer colors_of_neighbors(0:max_neighbors, 0:nm)
CMPF  ONDPU colors_of_neighbors
CMPF MAP colors_of_neighbors(MEMORY, ALLBITS)
      logical  exitflag
      integer count_w_color(MAX_NUM_OF_COLOR)
CMPF MAP weight(ALLBITS)
CMPF MAP v(ALLBITS)
CMPF MAP neighbors(ALLBITS)
CMPF MAP label_of_s(ALLBITS)
CMPF MAP selected_s(ALLBITS)
CMPF MAP max_label(ALLBITS)
CMPF MAP free_color(ALLBITS)
CMPF MAP mask(ALLBITS)
CMPF MAP notusedcolorflag(ALLBITS)

        interface
            function pranmar( jstate )
            INCLUDE 'size.h'
            real, array(0:nm) :: pranmar
            integer jstate
            end function 
        end interface

C     CALL cm_timer_clear(0)
C     CALL cm_timer_start(0)
      CALL FindAllNeighbors
c     print *, "find neighbors: "
C     CALL cm_timer_stop(0)
C     CALL cm_timer_print(0)
     


      maxnc = MAXVAL(n_connectivity_s)

      i = 1
      k = 3
      weight = -1
      total_weighted = 0
      do while (total_weighted .lt. nm)
C
C count up remaining neighbors of each vertex.
C neighbors that have been weighted are not counted.
        neighbors = 0
        do j = 0, maxnc -1
           where ((j .lt. n_connectivity_s) .and.
     $           (weight(neighbors_of_s(j, :)) .eq. -1))
               neighbors = neighbors + 1
           endwhere 
        enddo
C
C label vertices
        selected_s = 0
        where ((neighbors .le. k) .and. (weight .eq. -1))
          weight = i
          selected_s = 1
        endwhere
        i = i + 1
        weighted_this_pass = SUM(selected_s)
        total_weighted = total_weighted + weighted_this_pass
        if (weighted_this_pass .eq. 0) k = k + 1
C        print *, "Pass ", i, ", k = ", k
      enddo

      label_of_s = -1
      color_of_s = -1
      selected_s = 0 
      max_label = 0

      max_color = 0
      numColored = 0
      labels_of_neighbors = -1
      exitflag = .false. 
      count_w_color = 0

      label_of_s = pranmar(istate) * 2**24
      label_of_s=abs(label_of_s+((2**25)*weight))

      do while ((numColored .le. nm) .and. (.not. exitflag)) 
         do j = 0, maxnc-1
            where (j .lt. n_connectivity_s) 
             labels_of_neighbors(j,:)=label_of_s( 
     &                               neighbors_of_s(j,:)) 
             colors_of_neighbors(j,:)=color_of_s( 
     &                               neighbors_of_s(j,:)) 
            endwhere
         enddo 
         mask = .false.
         where (color_of_s .eq. -1)
           mask = .true.
         endwhere
         do j = 0, maxnc-1
            where ((j .lt. n_connectivity_s) .and.
     $             (label_of_s .le. labels_of_neighbors(j,:)))
                 mask=.false.
            endwhere
         enddo
         free_color=-1
         do i = 1, max_color+1
            where ((mask) .and. (free_color .eq. -1))
               notusedcolorflag=.true.
            elsewhere
               notusedcolorflag=.false.
            endwhere
            do j = 0, maxnc-1
               where ((j .lt. n_connectivity_s) .and.
     $              (notusedcolorflag) .and.
     $              (i .eq. colors_of_neighbors(j,:)))
                    notusedcolorflag=.false.
               endwhere
            enddo
            where (notusedcolorflag)
               free_color=i
            endwhere
         enddo
         where (mask)
               selected_s = 1  
               color_of_s = free_color
               label_of_s = -1
         end where  
         numColored = numColored + SUM(selected_s) 
         if (SUM(selected_s) .eq. 0) exitflag = .true.
         max_color = max(max_color,MAXVAL(free_color))
         selected_s = 0 
  99  enddo 
      do i=1,max_color
         where (color_of_s .eq. i)
            selected_s=1
         elsewhere
            selected_s=0
         endwhere
         count_w_color(i)=SUM(selected_s)
      enddo
c$$$      print 70,numColored, (count_w_color(k), k=1, max_color)
c$$$      Print *,"Total number of colors:",max_color
c$$$  70  format (I5,' -:', 20I3)
      RETURN
      end subroutine SmallestLastColorNodes 

