C**********************************************************
C                                                         *
C   COLOR TESTING HOST                                    *
C                                                         *
C**********************************************************
C
      PROGRAM TESTER

      INCLUDE "irreg.h"

      integer i, nodes, ntimes, completed, seed1, seed2
      integer ran
      external ran


C
C-- Start up Express and find out if we need to swap bytes.
C
      CALL KXINIT
      ISWAP = KXTSWA()
C     
      PGIND = KXRUN(NPROCS, 'node')
      IF(PGIND .LT. 0) THEN 
         WRITE(6,*) 'Failed to allocate nodes and load program.'
         CALL KXCLOS(PGIND)
         STOP
      ENDIF

      CALL KXPARA(ENV)

      call set_up_files

      WRITE(6,*) "Regular (0) or Auto number of times (#)"
      READ(5,*) ntimes
      completed=0

      WRITE(6,*) "Enter Initial Seed"
      READ(5,*) seed

      seed1=seed/seed_max
      seed2=seed - (seed_max * seed)

      call init_random(seed1,seed2)

      Call send_seed

      Do while (seed .gt. 0)
         call makemesh
         call send_mesh

         call get_results
         
CC    wait for the nodes to acknowledge completion
c     print *,"Waiting for Acknowledgement of completion"
         do i=0,(nprocs-1)
            status=kxread(type,4,i,999)
         end do
c     print *,"Host Passed Acknowledgement"
         completed=completed+1
         If (ntimes .eq. 0) then
            WRITE(6,*) "Enter New Seed, 0 to stop"
            READ(5,*) seed
         else
            if (completed .ge. ntimes) then
               seed=0
            else
               seed=ran(32000)
            endif
         endif
         Call send_seed
      enddo


      close(50)
C
C
C-- Close down the nodes.
C      

      WRITE(6,*) 'Finished'
      CALL KXCLOS(PGIND)
      
      END
      
C________________________________________________________

      SUBROUTINE send_seed
      include 'irreg.h'

            if (iswap .ne. 0)
     $           Call kxswap(seed,
     $           seed,4,1)
         status=kxbrod(seed,ihost,4,IALNOD,DUMMY,150)
            if (iswap .ne. 0)
     $           Call kxswap(seed,
     $           seed,4,1)

            write(6,*) "Running with seed =",seed
      return
      end
      
      subroutine get_results

      include 'irreg.h'
      integer algorithm,maxd,numcolors,numpasses,elaptime,flag
 49   format(7(1x,i10))

      flag=0
      do while (flag .eq. 0)
         status=kxread(algorithm,4,0,111)
         if (iswap .ne. 0)
     $        Call kxswap(algorithm,
     $        algorithm,4,1)
         
         if (algorithm .gt. 0) then
            status=kxread(maxd,4,0,112)
            if (iswap .ne. 0)
     $           Call kxswap(maxd,
     $           maxd,4,1)
            status=kxread(numcolors,4,0,113)
            if (iswap .ne. 0)
     $           Call kxswap(numcolors,
     $           numcolors,4,1)
            status=kxread(numpasses,4,0,114)
            if (iswap .ne. 0)
     $           Call kxswap(numpasses,
     $           numpasses,4,1)
            status=kxread(elaptime,4,0,115)
            if (iswap .ne. 0)
     $           Call kxswap(elaptime,
     $           elaptime,4,1)
            status=kxwrit(dummy,4,0,321)
            write(unit=50,fmt=49) algorithm,n,nprocs,maxd,numcolors,
     $           numpasses,elaptime
         else
            flag=1
         endif
      enddo
      
      return
      end


      subroutine set_up_files
      integer i(1:7)

      open(unit=49,file='auto.results',form='formatted',
     $     access='sequential',status='old',err=900)
      open(unit=50,file='auto.results~',form='formatted',
     $     access='sequential')
      
 700  read(unit=49,err=799,fmt=702) i(1),i(2),i(3),i(4),i(5),i(6),i(7)
      write(unit=50,fmt=702) i(1),i(2),i(3),i(4),i(5),i(6),i(7)
 702  format(7(1x,i10))
      goto 700
 799  continue
      close(49)
      close(50)

      open(unit=50,file='auto.results',form='formatted',
     $     access='sequential')
      open(unit=49,file='auto.results~',form='formatted',
     $     access='sequential',status='old')
      
 800  read(unit=49,err=899,fmt=702) i(1),i(2),i(3),i(4),i(5),i(6),i(7)
      write(unit=50,fmt=702) i(1),i(2),i(3),i(4),i(5),i(6),i(7)
      goto 800
 899  continue
      close(49)

      goto 1000

 900  continue

      open(unit=50,file='auto.results',form='formatted',
     $     access='sequential')

 1000 continue

      return
      end
