C-----------------------------------------------------------------------

C --- Assign random labels to each vertex.

      SUBROUTINE assign_rand_labels(range)

      INCLUDE 'irreg.h'

      integer range
      integer i,temp1

      REAL arandno
      REAL ranmar

      do i=0, npm
       arandno = ranmar()
       temp1 = arandno*(range)
       temp_label(i) = abs(temp1)
      end do
      return
      end

C-----------------------------------------------------------------------

      SUBROUTINE set_up_comm_sched

      INCLUDE 'irreg.h'
      integer i,index,j
            
      do i=0,nprocs-1
         dest(i)=0
      enddo
      
      
      do i=0,npm
	 index = proc_n(i)
         do j=0, index-1
            send(i,j)=neigh(i,j)/np
            if (send(i,j) .ne. procnum) dest(send(i,j))=1
         enddo
      enddo

      
      do i=0,nprocs-1
         if (i .ne. procnum) then
            status=kxwrit(dest(i),4,i,210)
         endif
      enddo
      do i=0,nprocs-1
         if (i .ne. procnum) then
            status=kxread(source(i),4,i,210)
         else
            source(i)=dest(i)
         endif
      enddo

C---- Getting the internal and external nodes --------------------------
      
      icount =0
      ecount =0
      
      do i=0, npm
         index = proc_n(i)
         flag =0
         do j=0, index-1
            if ( send(i,j) .ne. procnum) then
               flag = 1
            endif
         enddo
         if(flag .eq. 1) then
            external(ecount)=i
            ecount = ecount+1
         else
            internal(icount)=i
            icount = icount+1
         endif
      enddo

      end

C-----------------------------------------------------------------------
 
C --- Writes ALL labels to ALL processors, 
C --- i.e. way too much communication!
      
      subroutine pack_and_send
      
      include 'irreg.h'
      integer sizes(1:nprocs)

      status=kxconc(temp_label,4*np,label,4*np,
     $     sizes,ialnod,0,454)
      
      return
      end

C-----------------------------------------------------------------------
      
C --- Writes ALL colors to ALL processors, 
C --- i.e. way too much communication!
      
      subroutine pack_and_send_color
      
      include 'irreg.h'
      integer sizes(1:nprocs)

      status=kxconc(temp_color,4*np,color,4*np,
     $     sizes,ialnod,0,454)
      
      return
      end

C-----------------------------------------------------------------------

      integer function findmaxd()
      include 'irreg.h'
      
      external mymax
      integer tempmaxd,i,mymax
      
      tempmaxd=0
      do i=0,npm
         tempmaxd=max(tempmaxd,proc_n(i))
      enddo
      
      status=kxcomb(tempmaxd,mymax,4,1,IALNOD,0,101)
      
      findmaxd=tempmaxd
      return
      end

C-----------------------------------------------------------------------

      integer function findmind()
      include 'irreg.h'
      
      external mymin
      integer tempmind,i,mymin
      
      tempmind=0
      do i=0,npm
         tempmind=min(tempmind,proc_n(i))
      enddo
      
      status=kxcomb(tempmind,mymin,4,1,IALNOD,0,101)
      
      findmind=tempmind
      return
      end

C-----------------------------------------------------------------------

      integer function findmaxcolor()
      include 'irreg.h'
      
      external mymax
      integer tempmaxd,i,mymax
      
      tempmaxd=0
      do i=0,npm
         tempmaxd=max(tempmaxd,temp_color(i))
      enddo
      
      status=kxcomb(tempmaxd,mymax,4,1,IALNOD,0,101)
      
      findmaxcolor=tempmaxd
      return
      end

C-----------------------------------------------------------------------

C --- Find the global maximum.

       INTEGER FUNCTION MYMAX(V1, V2, SIZE)
       INTEGER V1, V2
       INTEGER SIZE
C     
       IF(V2 .GT. V1) THEN
          V1 = V2
       ENDIF
       MYMAX = 1
       RETURN
       END
C_______________________________________________________________________

C --- Find the global minimum.

       INTEGER FUNCTION MYMIN(V1, V2, SIZE)
       INTEGER V1, V2
       INTEGER SIZE
C     
       IF(V2 .LT. V1) THEN
          V1 = V2
       ENDIF
       MYMIN = 1
       RETURN
       END
C_______________________________________________________________________
       
C --- Find the global sum.
       
       INTEGER FUNCTION MYSUM(V1, V2, SIZE)
       INTEGER V1, V2
       INTEGER SIZE
C     
       V1 = V2 + V1
       MYSUM = 1
       RETURN
       END

C_______________________________________________________________________

C --- Make sure the coloring is correct, by checking that all neighbors
C --- have a different color.

      INTEGER FUNCTION test_colors

      INCLUDE 'irreg.h'
      INTEGER good_coloring, i,index,j, my_color
      EXTERNAL MYSUM
      INTEGER MYSUM
            
 
      CALL pack_and_send_color

      good_coloring = 1
      DO i=0,npm
	 global = i + procnum*np
         my_color = color(global)
	 index = proc_n(i)
         DO j=0, index-1
            IF (color(neigh(i,j)) .EQ. my_color) good_coloring = 0
         ENDDO
      ENDDO
 
C --- Combine the values for each processor.
      status=KXCOMB(good_coloring,MYSUM,4,1,IALNOD,0,101)

      IF (good_coloring.EQ.nprocs) THEN
	 test_colors = 1
      ELSE
	 test_colors = 0
      ENDIF
      RETURN
      END

