
/* 
   Analyze output results written to auto.results file.
   Average over runs and print out averages and errors.
*/

#include <stdio.h>

#define NumAlgs 3

char *AlgName[] = {"Jones-Plassmann     ", 
		   "Largest Degree First",
		   "Smallest Degree Last"};


int maxcolors[NumAlgs], mincolors[NumAlgs];
double avcolors[NumAlgs], avtime[NumAlgs], aviters[NumAlgs];
double errcolors[NumAlgs], errtime[NumAlgs];

main()
{
int algorithm, vertices, procs, maxdegree, colors, iters, time, count;
int n,alg;

   /* initialize everything */

   for (alg=0;alg<NumAlgs;alg++) 
   {
      count = 0;
      avcolors[alg] = 0.0;
      avtime[alg]   = 0.0;
      aviters[alg]  = 0.0;
      mincolors[alg] = 10000; 
      maxcolors[alg] = 0; 
   }

   while (scanf("%d",&algorithm) != EOF) {


      if (algorithm == 1) count++;
      algorithm--;

      /* Read in number of vertices */
      scanf("%d", &vertices);

      /* Read in number of processors */
      scanf("%d", &procs);

      /* Read in max degree */
      scanf("%d", &maxdegree);

      /* Read in number of colors */
      scanf("%d", &colors);
      avcolors[algorithm] += colors;
      if (colors < mincolors[algorithm]) mincolors[algorithm] = colors;
      if (colors > maxcolors[algorithm]) maxcolors[algorithm] = colors;

      /* Read in number of iterations */
      scanf("%d", &iters);
      aviters[algorithm] += iters;

      /* Read in time taken in microsecs (and convert to seconds) */
      scanf("%d", &time);
      avtime[algorithm] += (double)time / 1000000.0;

   }
   
   for (alg=0;alg<NumAlgs;alg++) 
   {
      avcolors[alg] /= count;
      avtime[alg]   /= count;
      aviters[alg]  /= count;
   }


   /* Print out results */

   printf("Number of vertices = %d\n", vertices);
   printf("Number of processors = %d\n", procs);
   printf("Number of measurements = %d\n", count);
   printf("\n");
   fflush(stdout);

   printf("     Algorithm          Average     Min     Max     Time (secs)\n");
   printf("                        Colors     Colors  Colors\n\n");

   for (alg=0;alg<NumAlgs;alg++) 
   {
      printf("%s %9.4f     %3d     %3d   %12.6f \n",
        AlgName[alg],avcolors[alg],mincolors[alg],maxcolors[alg],avtime[alg]);
   }
   printf("\nDone\n");
   fflush(stdout);

}

