C**********************************************************
C                                                         *
C   COLOR testing node process                            *
C                                                         *
C**********************************************************
C
      PROGRAM TESTER

      INCLUDE "irreg.h"
C
C-- Start up Express and find out if we need to swap bytes.
C
      CALL KXINIT
      ISWAP = KXTSWA()
C
C-- Get runtime parameters.
C
      CALL KXPARA(ENV)
      PROCNUM = ENV(1)
ccc      Print *,"Iswap is",iswap,procnum
c$$$      NPROCS = ENV(2)

      Call get_seed

      Do while (seed .gt. 0)
         
         Call get_mesh
         call update_node

         call tohost(999,procnum)

         call get_seed
         
      enddo

      END
      
C
C-- This function is used to pass information about our status back
C-- to the host.
C
      SUBROUTINE TOHOST(TYPE, V1)
      INTEGER TYPE, V1
      INTEGER BUF(1), ISTAT
      INTEGER KXWRIT, KXTSWA
      COMMON /XPRESS/ NOCARE, NORDER, NONODE, IHOST, IALNOD, IALPRC
      INTEGER         NOCARE, NORDER, NONODE, IHOST, IALNOD, IALPRC

      BUF(1) = V1
      IF(KXTSWA() .NE. 0) CALL KXSWAW(BUF, BUF, 4)
      ISTAT = KXWRIT(BUF, 4, IHOST, TYPE)
c***      print *,"I",procnum,type,buf(1)

      IF(TYPE .EQ. 99) STOP
      RETURN
      END


C-----------------------------------------------------------------------


      subroutine update_node

      include 'irreg.h'

      integer seed1,seed2,i
      COMMON /seedinfo/ seed1,seed2
      
      integer findmaxd,findmind
      integer findmaxcolor
      integer test_colors,OK
      integer mind,maxd,maxcolor,elaptime

      integer*4 starttime
      integer*4 kxtime
      external kxtime

      call set_up_comm_sched
      maxd=findmaxd()
      mind=findmind()

      if (procnum .eq. 0) print 110,maxd
 110  format(1x,"Maximum Degree is ",i4)
         
      
      DO i=1,ncol
         seed  = seed + 1
         seed1 = seed /seed_max
         seed2 = seed - (seed_max * seed)
         
         call init_random(seed1,seed2) ! to be moved in update nodes.
         
C112     format(1x,a,i4," colors with ",i4," passes in ",i10, 
C    $                  " microsecs  test =", i2)
 112     format(1x,a,i4," colors with ",i4," passes in ",i10, 
     $                  " microsecs")
         starttime=KXTIME()
         call jonesplass
         elaptime=KXTIME()-starttime
         maxcolor=findmaxcolor()
	 OK = test_colors()
         if (procnum .eq. 0) then
            print 112,"Jones Plassman    ",
C    $           maxcolor,color_count-1,elaptime, OK
     $           maxcolor,color_count-1,elaptime
            call tohost(111,1)
            call tohost(112,maxd)
            call tohost(113,maxcolor)
            call tohost(114,color_count-1)
            call tohost(115,elaptime)
            status=kxread(dummy,4,ihost,321)
         endif
         
         starttime=KXTIME()
         call degreegreedy
         elaptime=KXTIME()-starttime
         maxcolor=findmaxcolor()
	 OK = test_colors()
         if (procnum .eq. 0) then
            print 112,"Degree Greedy     ",
C    $           maxcolor,color_count-1,elaptime, OK
     $           maxcolor,color_count-1,elaptime
            call tohost(111,2)
            call tohost(112,maxd)
            call tohost(113,maxcolor)
            call tohost(114,color_count-1)
            call tohost(115,elaptime)
            status=kxread(dummy,4,ihost,321)
         endif
         
         starttime=KXTIME()
         call smalldeglast(maxd,mind)
         elaptime=KXTIME()-starttime
         maxcolor=findmaxcolor()
	 OK = test_colors()
         if (procnum .eq. 0) then
            print 112,"Small Deg Last    ",
C    $           maxcolor,color_count-1,elaptime, OK
     $           maxcolor,color_count-1,elaptime
            call tohost(111,3)
            call tohost(112,maxd)
            call tohost(113,maxcolor)
            call tohost(114,color_count-1)
            call tohost(115,elaptime)
            status=kxread(dummy,4,ihost,321)
         endif
         
c$$$         starttime=KXTIME()
c$$$         call balsmalldeglast(maxd,mind)
c$$$         elaptime=KXTIME()-starttime
c$$$         maxcolor=findmaxcolor()
c$$$         if (procnum .eq. 0) then
c$$$            print 112,"Bal Small Deg Last",
c$$$     $           maxcolor,color_count-1,elaptime
c$$$            call tohost(111,4)
c$$$            call tohost(112,maxd)
c$$$            call tohost(113,maxcolor)
c$$$            call tohost(114,color_count-1)
c$$$            call tohost(115,elaptime)
c$$$            status=kxread(dummy,4,ihost,321)
c$$$         endif

      ENDDO
      
      call tohost(111,-1)

      return
      end


C-----------------------------------------------------------------------

      SUBROUTINE get_seed
      include 'irreg.h'
      
      status=kxbrod(seed,ihost,4,IALNOD,DUMMY,150)
      status=kxbrod(ncol,ihost,4,IALNOD,DUMMY,160)
      end
      

