      SUBROUTINE send_mesh
      
      INCLUDE 'irreg.h'
      
      integer i,conn,j,k,offset
      integer index,temp
c$$$  integer l
      integer mesh_n(0:nm)
c$$$      integer node_info(0:npm,0:11)
      integer n_index(0:n6m)
      integer proc_info(0:np)
c$$$      real n_coord(0:dm,0:n6m),scoord(0:n18m),coord_buffer(0:n18m)

      common /makesend/ mesh_n,n_index
      
      
CC    Read the data from the files n_coord, n_info and n_count
c$$$      
c$$$      open(unit=45,file='n_info',form='formatted',
c$$$     &     access='sequential',status='old')
c$$$      
c$$$      open(unit=46,file='n_count',form='formatted',
c$$$     &     access='sequential',status='old')
c$$$      
c$$$      open(unit=47,file='n_coord',form='formatted',
c$$$     &     access='sequential',status='old')
c$$$      
c$$$      open(unit=48,file='np_coord',form='formatted',
c$$$     &     access='sequential',status='old')
c$$$      
c----------------------------------------------------------------------------
c--------------------GETTHE MESH DATA AND SEND IT TO NODES------------------
c----------------------------------------------------------------------------
      
C-----------getthe no. of neighbours per node
c$$$      
c$$$      
c$$$      do i= 0,nm
c$$$         read(45,*)mesh_n(i)
c$$$      enddo
c$$$      
C-----------getthe total number of neighbours per processor
      
      do i=0,nm
         k = i/nprocs
         proc_info(k)=proc_info(k)+mesh_n(i)
      enddo
      
      conn = ((6*(nm+1))-1)     ! total connectivity
c$$$      
c$$$      do i=0,conn
c$$$         read(46,*)n_index(i)
c$$$      enddo
      
c     do i=0,conn
c     print *,'n_index ',n_index(i)
c     enddo
      
c$$$      l=0
c$$$      do i=0,n6m
c$$$         read(48,fmt=68)n_coord(0,i),n_coord(1,i),n_coord(2,i)
c$$$ 68      format(F9.6,3X,F9.6,3X,F9.6)
c$$$         do j=0,2
c$$$            coord_buffer(l)=n_coord(j,i)
c$$$            l=l+1
c$$$         enddo
c$$$      enddo
c$$$      
c$$$      l=0
c$$$      do i=0,nm
c$$$         read(47,fmt=69)n_coord(0,i),n_coord(1,i),n_coord(2,i)
c$$$ 69      format(F9.6,3X,F9.6,3X,F9.6)
c$$$         do j=0,2
c$$$            scoord(l)=n_coord(j,i)
c$$$            l=l+1
c$$$         enddo
c$$$      enddo
c$$$      
      
c$$$      close(45)
c$$$      close(46)
c$$$      close(47)
c$$$      close(48)
      
CC    Do the communication
      
      do i=0,(nprocs-1)
         
c     print *,'Proc info is ',proc_info(i)
         offset=i*np
            if (iswap .ne. 0)
     $           Call kxswap(mesh_n(offset),
     $           mesh_n(offset),4,np)
         status=kxwrit(mesh_n(offset),4*np,i,100)
            if (iswap .ne. 0)
     $           Call kxswap(mesh_n(offset),
     $           mesh_n(offset),4,np)
      enddo
      
      
c$$$C     sending the coordinates of the nodes
c$$$      
c$$$      do i=0,(nprocs-1)
c$$$         
c$$$         offset = i*comm_data*3
c$$$         j = 0
c$$$         do j = 0, (comm_data-1)
c$$$            index =  j*3
c$$$            if (iswap .ne. 0)
c$$$     $           Call kxswap(scoord(offset+index),
c$$$     $           scoord(offset+index),4,3)
c$$$            status=kxwrit(scoord(offset+index),12,i,130)
c$$$            if (iswap .ne. 0)
c$$$     $           Call kxswap(scoord(offset+index),
c$$$     $           scoord(offset+index),4,3)
c$$$CCC            j = j+1
c$$$         enddo
c$$$      enddo

CC    wait for the nodes to acknowledge receipt
ccc      print *,"Waiting for Acknowledgement 1"
      do i=0,(nprocs-1)
         status=kxread(temp,4,i,99)
      end do
      print *,"Host Passed Acknowledgement 1 stage"
      
c     sending the indices of the neighbours
      
      index = 0
      do i=0,(nprocs-1)
         do j=0,npm
            offset = mesh_n(j+(np*i))
ccc      print *,'i is,offset is',i,offset
            if (iswap .ne. 0)
     $           Call kxswap(n_index(index),
     $           n_index(index),4,offset)
            status=kxwrit(n_index(index),4*offset,i,110)
            if (iswap .ne. 0)
     $           Call kxswap(n_index(index),
     $           n_index(index),4,offset)
            index = index+offset
         enddo
      enddo

CC    wait for the nodes to acknowledge receipt
ccc      print *,"Waiting for Acknowledgement 2"
      do i=0,(nprocs-1)
         status=kxread(temp,4,i,99)
      end do
      print *,"Host Passed Acknowledgement 2 stage"
      
c$$$C     sending the coordinates of the neighbours
c$$$      
c$$$      index =0
c$$$      do i=0,(nprocs-1)
c$$$         do j=0,(comm_data-1)
c$$$            offset = mesh_n(j+(comm_data*i))
c$$$c     print *,'iam offset is',i,offset
c$$$            if (iswap .ne. 0)
c$$$     $           Call kxswap(coord_buffer(index),
c$$$     $           coord_buffer(index),4,offset*3)
c$$$            status=kxwrit(coord_buffer(index),12*offset,i,120)
c$$$            if (iswap .ne. 0)
c$$$     $           Call kxswap(coord_buffer(index),
c$$$     $           coord_buffer(index),4,offset*3)
c$$$            index = index+offset
c$$$         enddo
c$$$      enddo
c$$$
c$$$CC    wait for the nodes to acknowledge receipt
c$$$ccc      print *,"Waiting for Acknowledgement 3"
c$$$      do i=0,(nprocs-1)
c$$$         status=kxread(temp,4,i,99)
c$$$      end do
c$$$      print *,"Host Passed Acknowledgement 3 stage"
    

c---------------------------------------------------------------------------
c-------------------SENT THE NODE DATA--------------------------------------
c-------------------------READ THE PARAMETERS-------------------------------
c---------------------------------------------------------------------------
c----------------------------------------------
c         print *,'Enter the random seed'
c         read *,seed
         
c          seed = 3467
c$$$
c$$$            if (iswap .ne. 0)
c$$$     $           Call kxswap(seed,
c$$$     $           seed,4,1)
c$$$         status=kxbrod(seed,ihost,4,IALNOD,DUMMY,150)
c$$$            if (iswap .ne. 0)
c$$$     $           Call kxswap(seed,
c$$$     $           seed,4,1)
c--------------------------------------------
c$$$
c$$$c         PRINT *, 'Input time_scale (how many multiples of 3n per measure'
c$$$c         READ(5,*)time_scale
c$$$         time_scale = 1
c$$$         call csend (160,time_scale,4,-1,0)
c$$$c         PRINT *,' time_scale = ', time_scale
c$$$c---------------------------------------------
c$$$
c$$$c         PRINT *, 'Input n_sweeps (independent measurements)_ '
c$$$c         READ(5,*)n_sweeps
c$$$         n_sweeps = 5
c$$$         call csend (170,n_sweeps,4,-1,0)
c$$$c         PRINT *,' n_sweeps = ', n_sweeps
c$$$c---------------------------------------------
c$$$
c$$$
c$$$c         PRINT *, 'Input n_correlated (internal loop)_ '
c$$$c         READ(5,*)n_correlated
c$$$         n_correlated = 5
c$$$         call csend (180,n_correlated,4,-1,0)
c$$$c         PRINT *,' n_correlated = ', n_correlated
c$$$c---------------------------------------------
c$$$
c$$$c         PRINT *, 'Input n_discard (internal loop)_ '
c$$$c        READ(5,*)n_discard
c$$$         n_discard = 5
c$$$         call csend (190,n_discard,4,-1,0)
c$$$c         PRINT *,' n_discard = ', n_discard
c$$$c---------------------------------------------
c$$$
c$$$c         PRINT *, 'Input lambda_ '
c$$$c         READ(5,*)lambda
c$$$         lambda = 1.0000
c$$$         call csend(200,lambda,4,-1,0)
c$$$c         PRINT *,' lambda = ', lambda
c$$$c---------------------------------------------
c$$$
c$$$c         PRINT *, 'Input trial_ '
c$$$c         READ(5,*)trial
c$$$         trial = 0.4000
c$$$         call csend(210,trial,4,-1,0)
c$$$c
c$$$c         PRINT *,' trial = ', trial
c$$$c---------------------------------------------
c         print *,'I am processor',iam
         return
         end
