CCCCCCCCCCCCCCC      DOMAIN DECOMPOSITION      CCCCCCCCCCCCCCCCCCCCC
CC                                                                CC
CC     At this moment, this is just for update_node portion       CC
CC     of the parallel code.  Its domain decoposition part        CC
CC     (or say coloring) is serial. The update_site part is       CC
CC     is in CM_FORTRAN.     L.H.                                 CC
CC                                                                CC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      PROGRAM pippo

      INCLUDE 'string.h'

      real ave, ave1, move_rate
      double precision elaptime
      double precision cm_timer_read_cm_busy
      double precision cm_timer_read_elapsed
      integer mpTimerElapsed
      external mpTimerstart, mpTimerElapsed
      double precision cols(1:4), time(1:4)
      integer i

      INTEGER i_sweep

      do i = 1, 4
        cols(i) = 0
        time(i) = 0
      end do

      CALL init

      ave = 0.0

 321  format(1x,a,i3," colors in ",f7.3,f7.3)
 322  format(1x,i8,i8,i8,f8.4)

      Call set_up_files

      DO i_sweep = 1, n_sweeps

          call set_up_random_graph
C         Call Flip_many_sites

         print *, 'i_sweep = ', i_sweep

         CALL mpTimerStart()

c$$$         Print *, "Jones Plassman Coloring"
         CALL JonesColorNodes

c$$$         print *, "color time: sec/iter "
         elaptime = mpTimerElapsed()/1000.0
c$$$         CALL cm_timer_print(0)
         print 321,"Jones Plass",max_color,elaptime
         write (unit=50,fmt=322) 1,n,max_color,elaptime
         cols(1) = cols(1) + max_color
         time(1) = time(1) + elaptime
C         call checkcolors

         
         CALL mpTimerStart()

c$$$         Print *, "MIS Coloring"
         CALL MISColorNodes

c$$$         print *, "color time: sec/iter "
         elaptime = mpTimerElapsed()/1000.0
c$$$         CALL cm_timer_print(0)
         print 321,"MIS        ",max_color,elaptime
         write (unit=50,fmt=322) 4,n,max_color,elaptime
         cols(4) = cols(4) + max_color
         time(4) = time(4) + elaptime
C         call checkcolors

         
         CALL mpTimerStart()

c$$$         Print *, "Degree Greedy Coloring"
         CALL DegGreedyColorNodes

c$$$         print *, "color time: sec/iter "
         elaptime = mpTimerElapsed()/1000.0
c$$$         CALL cm_timer_print(0)
         print 321,"Deg. Greedy",max_color,elaptime
         write (unit=50,fmt=322) 2,n,max_color,elaptime
         cols(2) = cols(2) + max_color
         time(2) = time(2) + elaptime
C         call checkcolors

         CALL mpTimerStart()

c$$$         Print *, "Smallest Degree Last Coloring"
         CALL SmallestLastColorNodes

c$$$         print *, "color time: sec/iter "
         elaptime = mpTimerElapsed()/1000.0
c$$$         CALL cm_timer_print(0)
         print 321,"Small. Last",max_color,elaptime
         write (unit=50,fmt=322) 3,n,max_color,elaptime
         cols(3) = cols(3) + max_color
         time(3) = time(3) + elaptime
C         call checkcolors

c$$$         
c$$$         
c$$$         CALL mpTimerStart()

c$$$         CALL update_many_sites

c$$$         print *, "update time: sec/iter "
c$$$         elaptime = mpTimerElapsed()
c$$$         CALL cm_timer_print(0)
c$$$
c$$$         Call measure
c$$$
c$$$         ave = ave + sw_obs(3)
c$$$         ave1 = ave/(i_sweep*35)
c$$$         print *, 'ave_gauss = ', ave1
c$$$         move_rate = sum(sw_sacc)/36
c$$$         print *, 'move_rate = ', move_rate

      ENDDO
c$$$      STOP

      print *, "Jones-Plassmann ", cols(1)/n_sweeps, time(1)/n_sweeps
      print *, "MIS             ", cols(4)/n_sweeps, time(4)/n_sweeps
      print *, "Largest  First  ", cols(2)/n_sweeps, time(2)/n_sweeps
      print *, "Smallest Last   ", cols(3)/n_sweeps, time(3)/n_sweeps
      END


C_______________________________________________________________________

      SUBROUTINE init

      INCLUDE 'string.h'

      INTEGER i, io, i_two, i_three, m0
      INTEGER id, is, im
      INTEGER rnx, rny, rn, ri_seed1, ri_seed2, rtime_scale, rn_sweeps
      INTEGER rn_correlated, rn_discard,rwrite_all
      REAL*4 a, rlambda, rtrial
      real ranmar
      INTEGER start_mode, i_seed2

c      print *, "start_mode = ???"
c      read *, start_mode
      start_mode=0
      PRINT *,' i_seed1 = '
      READ(5,*)i_seed1
C**      i_seed1=11
c      PRINT *,' i_seed1 = ', i_seed1
c      PRINT *, 'Input second i_seed (0 <= seed <= 30081) _ '
c      READ(5,*)i_seed2
      i_seed2=12
c      PRINT *,' i_seed2 = ', i_seed2
c      PRINT *, 'Lambda ? '
c      READ(5,*)lambda
      lambda=1.5
c      PRINT *,' lambda = ', lambda
      PRINT *, 'n_sweeps ? '
      READ(5,*)n_sweeps
      PRINT *,' n_sweeps = ', n_sweeps
c      PRINT *, 'trial ? '
c      READ(5,*)trial
      trial=0.5
c      PRINT *,' trial = ', trial
c$$$
c$$$      IF(start_mode .EQ. -1)THEN
c$$$        OPEN(unit=f_ico,status='old',file='aaa.ico')
c$$$        read(f_ico,*)rnx,rny,rn,ri_seed1,ri_seed2,rtime_scale,rn_sweeps
c$$$     $       ,rn_correlated,rn_discard,rlambda,rtrial,rwrite_all
c$$$        if(rnx.ne.nx)then
c$$$           print*,rnx,nx
c$$$           stop'rnx .ne. nx'
c$$$        endif
c$$$        if(rny.ne.ny)then
c$$$           print*,rny,ny
c$$$           stop'rny .ne. ny'
c$$$        endif
c$$$        if(rn.ne.n)then
c$$$           print*,rn,n
c$$$           stop'rn .ne. n'
c$$$        endif
c$$$        read(f_ico,387)(rand_u(id),id=1,97)
c$$$        read(f_ico,387)rand_c, rand_cd, rand_cm
c$$$        read(f_ico,*)rand_i97, rand_j97, rand_ivec, rand_test
c$$$        read(f_ico,387)((field           (id,is),id=0,dm),is=0, nm)
c$$$        read(f_ico,387)(square_m        (   im)        ,im=0,n6m)
c$$$        read(f_ico,387)((lno_m           (id,im),id=0,dm),im=0,n6m)
c$$$        read(f_ico,387)((rno_m           (id,im),id=0,dm),im=0,n6m)
c$$$        read(f_ico,*)(m_start_s       (   is)        ,is=0, nm)
c$$$        read(f_ico,*)(n_connectivity_s(   is)        ,is=0, nm)
c$$$        read(f_ico,*)(edge_m          (   im)        ,im=0,n6m)
c$$$        read(f_ico,*)(s_site_m        (   im)        ,im=0,n6m)
c$$$        read(f_ico,*)(s_neighbor_m    (   im)        ,im=0,n6m)
c$$$        read(f_ico,*)(m_next_m        (   im)        ,im=0,n6m)
c$$$        read(f_ico,*)(m_former_m      (   im)        ,im=0,n6m)
c$$$        read(f_ico,*)(m_back_m        (   im)        ,im=0,n6m)
c$$$ 387    format(1x,4g16.7)
c$$$        close(f_ico)
c$$$      ELSE
        CALL rmarin(i_seed1,i_seed2)
        call init_random(i_seed1, i_seed2)
c$$$      ENDIF
c$$$
c$$$      inv_n = 1.0/float(n)

C      CALL set_up_mesh
C      call set_up_random_graph
c$$$      


      RETURN
      END

C_______________________________________________________________________

      SUBROUTINE set_up_mesh

      INCLUDE 'string.h'

      INTEGER site, site1, s0, s2, m_start, m_start2
      integer nc,nc1,i,j
      INTEGER d0, m0, s1
      real scratch

      DO site = 0 , nm
        m_start_s(site) = 6 * site
        n_connectivity_s(site) = 6
      ENDDO

      DO site = 0 , nm
        s_neighbor_m(6*site+0) = site + 1
        s_neighbor_m(6*site+1) = site + nx + 1
        s_neighbor_m(6*site+2) = site + nx
        s_neighbor_m(6*site+3) = site - 1
        s_neighbor_m(6*site+4) = site - nx - 1
        s_neighbor_m(6*site+5) = site - nx

        DO site1 = 0, 5
          m_next_m  (6*site+site1) = 6*site + site1 + 1
          m_former_m(6*site+site1) = 6*site + site1 - 1
          s_site_m  (6*site+site1) = site
        ENDDO
        m_next_m   ( 6*site + 5 ) = 6*site
        m_former_m ( 6*site     ) = 6*site + 5

        IF(site .LT. nx)THEN
          s_neighbor_m(6*site+5) = site + nx*(ny-1)
          s_neighbor_m(6*site+4) = site + nx*(ny-1) - 1
        ENDIF
        IF(nx*ny-1-site .LT. nx)then
          s_neighbor_m(6*site+2) = site - nx*(ny-1)
          s_neighbor_m(6*site+1) = site - nx*(ny-1) + 1
        ENDIF
        IF(mod(site,nx) .eq. nx-1)then
          s_neighbor_m(6*site+0) = site - nx + 1
          s_neighbor_m(6*site+1) = site + 1
        ENDIF
        IF(mod(site,nx) .eq. 0)then
          s_neighbor_m(6*site+3) = site + nx - 1
          s_neighbor_m(6*site+4) = site - 1
        ENDIF
      ENDDO

      s_neighbor_m(0+4) = nx * ny - 1
      s_neighbor_m(6*(nx*ny-1)+1) = 0

      DO s0=0, nm
        m_start = m_start_s(s0)
        nc = n_connectivity_s(s0)
        do i=1,nc
           s2 = s_neighbor_m(m_start)
           m_start2 = m_start_s(s2)
           nc1 = n_connectivity_s(s2)
           do j=1,nc1
              IF(s0.EQ.s_neighbor_m(m_start2))GOTO 52
              m_start2 = m_next_m(m_start2)
           enddo
 52        CONTINUE

CC    here m_start and m_start2 are the two opposite links.
           m_back_m(m_start ) = m_start2
           m_back_m(m_start2) = m_start
           m_start = m_next_m(m_start)
        enddo
      ENDDO

c$$$      CALL CMF_RANDOM(field, 1.0)
c$$$
c$$$
c$$$      DO m0 = 0, n6m
c$$$        square_m(m0) = 0.0
c$$$        s0 = s_site_m(m0)
c$$$        s1 = s_neighbor_m(m0)
c$$$        DO d0 = 0, dm
c$$$          scratch = field(d0,s0)-field(d0,s1)
c$$$          square_m(m0) = square_m(m0) + scratch * scratch
c$$$        ENDDO
c$$$      ENDDO
c$$$
c$$$C     print *,(square_m(j),j=0,nm)

      RETURN
      END

C **************************************************************************
      SUBROUTINE rmarin(ij,kl)
C This is the initialization routine for the random number generator
C     RANMAR()
C NOTE: The seed variables can have values between:    0 <= IJ <= 31328
C                                                      0 <= KL <= 30081
      REAL u(97), c, cd, cm
      INTEGER i97, j97, ivec
      LOGICAL test
      COMMON /raset1/ u
      COMMON /raset2/ c, cd, cm, i97, j97, ivec, test

      IF( ij .LT. 0  .OR.  ij .GT. 31328  .OR.
     *    kl .LT. 0  .OR.  kl .GT. 30081 ) THEN
        PRINT '(A)', ' The first random number seed must have a value
     *between 0 and 31328'
        PRINT '(A)',' The second seed must have a value between 0 and
     *30081'
        STOP
      ENDIF
      i = mod(ij/177, 177) + 2
      j = mod(ij    , 177) + 2
      k = mod(kl/169, 178) + 1
      l = mod(kl,     169)
      DO 2 ii = 1, 97
        s = 0.0
        t = 0.5
        DO 3 jj = 1, 24
          m = mod(mod(i*j, 179)*k, 179)
          i = j
          j = k
          k = m
          l = mod(53*l+1, 169)
          IF (mod(l*m, 64) .ge. 32) then
            s = s + t
          ENDIF
          t = 0.5 * t
    3   CONTINUE
        u(ii) = s
    2 CONTINUE
      c = 362436.0 / 16777216.0
      cd = 7654321.0 / 16777216.0
      cm = 16777213.0 /16777216.0
      i97 = 97
      j97 = 33
      test = .true.
      RETURN
      END
C **************************************************************************
C **************************************************************************
      FUNCTION ranmar()
      IMPLICIT NONE
      REAL rand_u(97), rand_c, rand_cd, rand_cm, rand_uni, ranmar
      INTEGER rand_i97, rand_j97, rand_ivec
      LOGICAL rand_test
      COMMON /raset1/ rand_u
      COMMON /raset2/ rand_c, rand_cd, rand_cm, rand_i97
     $     , rand_j97, rand_ivec, rand_test

      IF( .NOT. rand_test ) THEN
        PRINT '(A)',' Call the init routine (RMARIN) before calling RAN
     *MAR'
        STOP
      ENDIF
      rand_uni = rand_u(rand_i97) - rand_u(rand_j97)
      IF( rand_uni .LT. 0.0 ) rand_uni = rand_uni + 1.0
      rand_u(rand_i97) = rand_uni
      rand_i97 = rand_i97 - 1
      IF(rand_i97 .EQ. 0) rand_i97 = 97
      rand_j97 = rand_j97 - 1
      IF(rand_j97 .EQ. 0) rand_j97 = 97
      rand_c = rand_c - rand_cd
      IF( rand_c .LT. 0.0 ) rand_c = rand_c + rand_cm
      rand_uni = rand_uni - rand_c
      IF( rand_uni .LT. 0.0 ) rand_uni = rand_uni + 1.0
      ranmar = rand_uni
      RETURN
      END
C **************************************************************************

      BLOCK DATA
      REAL u(97), c, cd, cm
      INTEGER i97, j97, ivec
      LOGICAL test
      COMMON /raset1/ u
      COMMON /raset2/ c, cd, cm, i97, j97, ivec, test
      DATA test /.false./
      END

C_______________________________________________________________________

      subroutine set_up_files
      integer i(1:4)
      
c$$$      open(unit=49,file='auto.results',form='formatted',
c$$$     $     access='sequential',status='old',err=900)
c$$$      open(unit=50,file='auto.results~',form='formatted',
c$$$     $     access='sequential',status='unknown')
c$$$      
c$$$ 700  read(unit=49,err=799,fmt=702) i(1),i(2),i(3),i(4)
c$$$      write(unit=50,fmt=702) i(1),i(2),i(3),i(4)
c$$$ 702  format(7(1x,i10))
c$$$      goto 700
c$$$ 799  continue
c$$$      close(49)
c$$$      close(50)
c$$$
c$$$      open(unit=50,file='auto.results',form='formatted',
c$$$     $     access='sequential',status='unknown')
c$$$      open(unit=49,file='auto.results~',form='formatted',
c$$$     $     access='sequential',status='old')
c$$$      
c$$$ 800  read(unit=49,err=899,fmt=702) i(1),i(2),i(3),i(4)
c$$$      write(unit=50,fmt=702) i(1),i(2),i(3),i(4)
c$$$      goto 800
c$$$ 899  continue
c$$$      close(49)
c$$$
c$$$      goto 1000
c$$$
c$$$ 900  continue

      open(unit=50,file='auto.results.temp',form='formatted',
     $     access='sequential',status='unknown')

 1000 continue

      return
      end
c------------Random Number Generator-----------------------------

c *****************************************************************************
c ***   Dec mpp12000 Fortran Random Numbers Generator                       ***
c ***   =============================================                       ***
c ***    Provides uniformly distributed random numbers using a combination  ***
c ***    of lagged Fibonaci and arithmetic sequence generators. It assumes  ***
c ***    that the desired geometry of target arrays is 2 dimensional and    ***
c ***    of sizes 128x64, but can be changed to any target dimension/size.  ***
c ***                                                                       ***
c ***   By J. Apostolakis, M. Guagnelli, E. Marinari                        ***
c ***   --------------------------------------------                        ***
c ***   Syracuse University -- v1.0 -- March, 21, 1992                      ***
c *****************************************************************************
c ***   Based on universal random number generator for sequential computers ***
c ***   of Marsaglia, Zaman and Tsang, Stat. Prob. Lett. 9 (1990) 35.       ***
c ***   as presented in F. James, Comp. Phys. Comm. 60 (1990) 329, it is    ***
c ***   the generator "RANMAR" p.339                                        ***
c ***   With comments, or for corrections or updates contact                ***
c ***                                   japost@nova.npac.syr.edu            ***
c *****************************************************************************

c **************************************************************************
c ***  SUBROUTINE init_random ( seed1, seed2 )
c ***   Accepts two seeds and initialises all working parts of the 
c ***   random number generator(RNG). Uses a simple sequential RNG (#1) to
c ***   seed a parallel version of MZT's initialising RNG (#2), which in
c ***   turn is used to seed the lagged Fibonaci part of the overall RNG.
c ***   The seeds must be in the range [0,31328] and [0,30081] respectively 
c **************************************************************************
	subroutine init_random ( seed1, seed2 )
	implicit none
	include 'size.h'

c *** Parameters of RNG No 1 , of the multiplicative linear congruent    ***
c *** type which is used to provide indepedent starting points for       ***
c *** the seeding of the initialising parallel RNG.                      ***
c **************************************************************************
	integer    ia, ic, im, x1_max, x2_max
	parameter (ia = 967)
	parameter (ic = 3041)
	parameter (im = 14406)
c *** The upper limits on the seeds for the parallel initialising        ***
c ***  generator (Rng no 2).      					 ***
c **************************************************************************
	parameter (x1_max = 31328)
	parameter (x2_max = 30081)

	integer    i97, j97, ii, jj, Seed1, Seed2
	integer,   array(0:nm)    :: se1, se2, i, j, k, l, m
	real       c, cd, cm
	real,      array(0:nm, 97) :: u
	real,      array(0:nm)    :: s, t

c **************************************************************************
c **  The variables in these common statements specify the state of the
c **  parallel random number generator and must all be saved and restored
c **  in order to continue in a later run from a certain point in a sequence.
c **************************************************************************
	common /mp_urandom/   u
  	common /mp_numbers/   c, cd, cm, i97, j97
	
CMPF ONDPU mp_urandom
CMPF ONDPU se1, se2, i, j, k, l, m
CMPF MAP   u   ( ALLBITS, MEMORY )
CMPF MAP   se1 ( ALLBITS )
CMPF MAP   se2 ( ALLBITS )
CMPF MAP   i   ( ALLBITS )
CMPF MAP   j   ( ALLBITS )
CMPF MAP   k   ( ALLBITS )
CMPF MAP   l   ( ALLBITS )
CMPF MAP   m   ( ALLBITS )
CMPF MAP   s   ( ALLBITS )
CMPF MAP   t   ( ALLBITS )

c **************************************************************************
c ** Loop over processors, getting new seeds for each processor.
c **************************************************************************

	do ii = 0, nm
	  seed1 = mod((seed1 * ia + ic), im)
	  seed2 = mod((seed2 * ia + ic), im)
	  se1(ii) = ((x1_max + 1) * seed1) / im
	  se2(ii) = ((x2_max + 1) * seed2) / im
	enddo

c **************************************************************************
c *** Having initialized the seeds arrays se1 and se2, we use them      ***
c *** to initialize the working array u of the Fibonaci part of our     ***
c *** random number generator, in parallel.                  		***
c *************************************************************************

	i = mod(se1/177, 177) + 2
	j = mod(se1    , 177) + 2
        k = mod(se2/169, 178) + 1
	l = mod(se2,     169)

	do ii = 1, 97
	  s = 0.0
	  t = 0.5
	  do jj = 1, 24
	    m = mod(mod(i*j, 179)*k, 179)
	    i = j
	    j = k
 	    k = m
	    l = mod(53*l+1, 169)
	    where ( mod(l*m, 64) .ge. 32 )
	      s = s + t
	    endwhere
	    t = 0.5 * t
	  enddo
	  u(:, ii) = s
	enddo
	c   = 362436.0   / 16777216.0
	cd  = 7654321.0  / 16777216.0
	cm  = 16777213.0 / 16777216.0
	i97 = 97
	j97 = 33

	return
	end

c --------------------------------------------------------------------------

c **************************************************************************
c ***  FUNCTION pranmar( seed )                                          ***
c ***   Returns one random number in [0,1) on every processor of a       ***
c ***   machine configured as a nx x ny array                            ***
c **************************************************************************
        function pranmar( state )
        implicit none
        include 'size.h'
 	real, array(0:nm) :: pranmar
        integer state
c       this integer is unused, but required to make function compile.

	integer  i97, j97, ii, jj
	real     c, cd, cm
	real,    array(0:nm,97) :: u
	real,    array(0:nm)    :: r

	common /mp_urandom/   u
	common /mp_rrandom/   r
  	common /mp_numbers/   c, cd, cm, i97, j97
	
CMPF ONDPU mp_urandom
CMPF ONDPU mp_rrandom
CMPF MAP   u   ( ALLBITS, MEMORY )
CMPF MAP   r   ( ALLBITS )

	r = u(:,i97) - u(:,j97)
	where ( r .lt. 0.0 ) r = r + 1.0
	u(:,i97) = r
	i97 = i97 - 1
	if ( i97 .eq. 0 ) i97 = 97
	j97 = j97 - 1
	if ( j97 .eq. 0 ) j97 = 97
	c = c - cd
	if ( c .lt. 0.0 ) c = c + cm
	r = r - c
	where ( r .lt. 0.0 ) r = r + 1.0

        pranmar = r
	return
	end

c -----------------------------------------------------------------------

